.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm

; Usage:

FcDemo3Regs	PROTO		; the procedure has 3 arguments, all three are passed through registers
; fcinv FcDemo3Regs, ecx:82, edx:offset MainString, eax:offset SubString

FcDemo2Regs	PROTO: DWORD	; the procedure has 3 arguments, one is passed on the stack
; fcinv FcDemo2Regs, ecx:82, edx:offset MainString, offset SubString

; same for obtaining timings in a standardised format:
; timings FcDemo2Regs, ecx:82, edx:offset MainString, offset SubString

fcinv MACRO algo, a1, a2, a3, a4, a5, a6
LOCAL invAlgo$, out$, Description, movreg1, movreg2, movreg3
  movreg1 equ <>
  movreg2 equ <>
  movreg3 equ <>
  invAlgo$ CATSTR <invoke >, <algo>
  ifnb <a1>
	if @InStr(1, <a1>, <:>) eq 4
		movreg1 CATSTR <mov >, @SubStr(<a1>, 1, 3), <, >, @SubStr(<a1>, 5)
	else
		invAlgo$ CATSTR invAlgo$, <, >, <a1>
	endif
  ifnb <a2>
	if @InStr(1, <a2>, <:>) eq 4
		movreg2 CATSTR <mov >, @SubStr(<a2>, 1, 3), <, >, @SubStr(<a2>, 5)
	else
		invAlgo$ CATSTR invAlgo$, <, >, <a2>
	endif
  ifnb <a3>
	if @InStr(1, <a3>, <:>) eq 4
		movreg3 CATSTR <mov >, @SubStr(<a3>, 1, 3), <, >, @SubStr(<a3>, 5)
	else
		invAlgo$ CATSTR invAlgo$, <, >, <a3>
	endif
  ifnb <a4>
	invAlgo$ CATSTR invAlgo$, <, >, <a4>
  ifnb <a5>
	invAlgo$ CATSTR invAlgo$, <, >, <a5>
  endif
  endif
  endif
  endif
  endif
  movreg1		;; mov eax, offset arg1 (for example)
  movreg2		;; mov ecx, offset arg2
  movreg3		;; mov edx, offset arg3
;;   % echo invAlgo$	; uncomment in case of problems
  invAlgo$		;; invoke MyAlgo, arg4, arg5, arg6
ENDM

;	Usage:
;	timings InString, 1, addr MainString, addr SubString
;	timings FcDemo2Regs, ecx:82, edx:offset MainString, addr SubString	; the FASTCALL variant

timings MACRO algo, a1, a2, a3, a4, a5, a6
LOCAL invAlgo$, out$, Description, movreg1, movreg2, movreg3
  movreg1 equ <>
  movreg2 equ <>
  movreg3 equ <>
  ifndef LOOP_COUNT
	LOOP_COUNT = 1000000/10	;; default: one Million
  endif
  ifndef CurAlgo
  	CurAlgo equ <>
  endif
  ifdif CurAlgo, <algo>
  	CurAlgo equ <algo>
  endif

  Description equ <CurAlgo>

  invAlgo$ CATSTR <invoke >, <algo>
  ifnb <a1>
	if @InStr(1, <a1>, <:>) eq 4
		movreg1 CATSTR <mov >, @SubStr(<a1>, 1, 3), <, >, @SubStr(<a1>, 5)
	else
		invAlgo$ CATSTR invAlgo$, <, >, <a1>
	endif
	Description CATSTR Description, <, >, <a1>

  ifnb <a2>
	if @InStr(1, <a2>, <:>) eq 4
		movreg2 CATSTR <mov >, @SubStr(<a2>, 1, 3), <, >, @SubStr(<a2>, 5)
	else
		invAlgo$ CATSTR invAlgo$, <, >, <a2>
	endif
	Description CATSTR Description, <, >, <a2>
  ifnb <a3>
	if @InStr(1, <a3>, <:>) eq 4
		movreg3 CATSTR <mov >, @SubStr(<a3>, 1, 3), <, >, @SubStr(<a3>, 5)
	else
		invAlgo$ CATSTR invAlgo$, <, >, <a3>
	endif
	Description CATSTR Description, <, >, <a3>
  ifnb <a4>
	invAlgo$ CATSTR invAlgo$, <, >, <a4>
	Description CATSTR Description, <, >, <a4>
  ifnb <a5>
	invAlgo$ CATSTR invAlgo$, <, >, <a5>
	Description CATSTR Description, <, >, <a5>
  endif
  endif
  endif
  endif
  endif
  ifndef globcycles		;; we might need to calculate a global average count
  	.data?
  	globcycles	dd ?
  	globcount	dd ?
  	.code
  endif
  ifndef REP_CT
	REP_CT = 1
  endif
  ifndef REP_CTold
	REP_CTold = REP_CT
  endif
  if REP_CT gt 1
  	if REP_CTold eq 1
  		pushad
		print chr$(13, 10)
		popad
	endif
	REP_CTold = REP_CT
  endif
  ;% echo invAlgo$			;; uncomment to see what exactly you are invoking
  REPEAT REP_CT
	pushad
	invoke Sleep, 50
	popad
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		movreg1
		movreg2
		movreg3
		invAlgo$
	counter_end
	add globcycles, eax
	inc globcount
	out$ CATSTR <print str$(eax), 9, ">, Description, <", 13, 10>
	out$
  ENDM
  if REP_CT gt 1
	print chr$(13, 10)
  endif
ENDM

.code
SourceString	db "This is a long string meant for testing the Masm32 lib InString algo, and we want to find the word 'end'", 0
SubString	db "end", 0

start:
	print "The InString results are "
	fcinv FcDemo2Regs, ecx:70, edx:offset SourceString, addr SubString
	print str$(eax), "/"
	fcinv FcDemo3Regs, ecx:70, edx:offset SourceString, eax:offset SubString
	print str$(eax), "/"
	fcinv FcDemo2Regs, ecx:1, edx:chr$("Does this string have an end?"), offset SubString
	print str$(eax), 13, 10, 10

	timings FcDemo3Regs, ecx:70, edx:offset SourceString, eax:offset SubString
	timings FcDemo2Regs, ecx:70, edx:offset SourceString, addr SubString
	timings FcDemo2Regs, ecx:1, edx:chr$("Does this string have an end?"), offset SubString

	invoke Sleep, 50
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS				; --------- the traditional way ---------
		invoke InString, 1, addr SourceString, addr SubString
	counter_end
	print str$(eax), 9, "InString, 1, addr SourceString, addr SubString", 13, 10	; --------- end traditional way ---------

	and globcycles, 0	; reset the average cycles counter
	and globcount, 0

	REP_CT = 5						; optional: perform the timings for five lines, to see the variance
	timings InString, 1, addr SourceString, addr SubString		; --------- with the timings macro: one line ---------

	print chr$("Average cycle count:" , 9)
	mov eax, globcycles
	cdq
	div globcount
	print str$(eax), 13, 10, 10	

	inkey "--- ok ---"
	exit

FcDemo2Regs proc arg3:DWORD
	invoke InString, ecx, edx, arg3
	ret
FcDemo2Regs endp

FcDemo3Regs proc
	invoke InString, ecx, edx, eax
	ret
FcDemo3Regs endp

end start

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
